﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace Higuchi.Net.Pop3.Command
{
    /// <summary>Represents list command.
    /// </summary>
    public class List : Pop3Command
    {
        private Int64? _MailIndex = null;
		/// <summary>
		/// 
		/// </summary>
        public override String Name
        {
            get { return "List"; }
        }
		/// <summary>
		/// 
		/// </summary>
        public Int64? MailIndex
        {
            get { return this._MailIndex; }
            set { this._MailIndex = value; }
        }
		/// <summary>
		/// 
		/// </summary>
        public List()
        {
        }
		/// <summary>
		/// 
		/// </summary>
		/// <param name="mailIndex"></param>
        public List(Int64 mailIndex)
        {
            if (mailIndex < 1)
            { throw new ArgumentException(); }
            this._MailIndex = mailIndex;
        }
		/// <summary>
		/// 
		/// </summary>
		/// <returns></returns>
        public override String GetCommandString()
        {
			if (_MailIndex.HasValue == true)
			{
				return String.Format("{0} {1}", this.Name, this._MailIndex);
			}
			return this.Name;
        }
        /// <summary>Analyze response single line and get mail index.
        /// </summary>
        /// <param name="line"></param>
        /// <returns></returns>
        public static Int64 GetMessageIndex(String line)
        {
            return Int64.Parse(Regex.Replace(line.Replace("\r\n", "")
                , @"^([0-9]+)[ |	]+.*$", "$1"));
        }
		/// <summary>Analyze response single line and get mail size.
		/// </summary>
        /// <param name="line"></param>
        /// <returns></returns>
        public static Int32 GetSize(String line)
        {
            return Int32.Parse(Regex.Replace(line.Replace("\r\n", "")
                , @"^[0-9]+[ |	]+([0-9]+).*$", "$1"));
        }
		/// <summary>Represents result of list command.
		/// </summary>
        public class Result
        {
            private Int64 _MailIndex = 0;
            private Int32 _Size = 0;
			/// <summary>
			/// 
			/// </summary>
            public Int64 MailIndex
            {
                get { return this._MailIndex; }
            }
			/// <summary>
			/// 
			/// </summary>
            public Int32 Size
            {
                get { return this._Size; }
            }
			/// <summary>
			/// 
			/// </summary>
			/// <param name="text"></param>
            public Result(String text)
            {
                this._MailIndex = List.GetMessageIndex(text);
                this._Size = List.GetSize(text);
            }
        }
    }
}
