﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace Higuchi.Net.Pop3.Command
{
    /// <summary>Represents stat command.
    /// </summary>
    public class Stat : Pop3Command
    {
		/// <summary>
		/// 
		/// </summary>
        public override String Name
        {
            get { return "Stat"; }
        }
		/// <summary>
		/// 
		/// </summary>
		/// <returns></returns>
        public override String GetCommandString()
        {
            return this.Name;
        }
        /// <summary>Analyze response single line and get total mail count of mailbox.
        /// </summary>
        /// <param name="text"></param>
        /// <returns></returns>
        public static Int64 GetTotalMessageCount(String text)
        {
            return Int64.Parse(Regex.Replace(text.Replace("\r\n", "")
                , @"^.*\+OK[ |	]+([0-9]+)[ |	]+.*$", "$1"));
        }
		/// <summary>Analyze response single line and get total mail size of mailbox.
		/// </summary>
        /// <param name="text"></param>
        /// <returns></returns>
        public static Int64 GetTotalSize(String text)
        {
            return Int64.Parse(Regex.Replace(text.Replace("\r\n", "")
                , @"^.*\+OK[ |	]+[0-9]+[ |	]+([0-9]+).*$", "$1"));
        }
		/// <summary>Represents result of stat command.
		/// </summary>
        public class Result
        {
            private Int64 _TotalMessageCount = 0;
            private Int64 _TotalSize = 0;
			/// <summary>
			/// 
			/// </summary>
            public Int64 TotalMessageCount
            {
                get { return this._TotalMessageCount; }
            }
			/// <summary>
			/// 
			/// </summary>
            public Int64 TotalSize
            {
                get { return this._TotalSize; }
            }
			/// <summary>
			/// 
			/// </summary>
			/// <param name="text"></param>
            public Result(String text)
            {
                this._TotalMessageCount = Stat.GetTotalMessageCount(text);
                this._TotalSize = Stat.GetTotalSize(text);
            }
        }
    }
}
