﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Net.Sockets;
using Higuchi.Net.Mail;

namespace Higuchi.Net.Smtp
{
	public class DefaultRelayValidator : IRelayValidator
	{
		private List<IPAddress> _IPAddressList = new List<IPAddress>();
		private Boolean _RequireAuthenticate = false;
		public List<IPAddress> IPAddressList
		{
			get { return _IPAddressList; }
		}
		public Boolean RequireAuthenticate
		{
			get { return _RequireAuthenticate; }
			set { _RequireAuthenticate = value; }
		}
		public DefaultRelayValidator()
		{
		}
		public Boolean Validate(Socket socket, Boolean authenticated)
		{
			IPAddress ip = Server.GetRemoteIPAddress(socket);

			if (_RequireAuthenticate == true && authenticated == false)
			{ return false; }

			if (ip != null)
			{
				return _IPAddressList.Contains(ip);
			}
			return true;
		}
	}
}
