﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Higuchi.Net.Mail;

namespace Higuchi.Net.Smtp
{
	internal class PlainAuthenticatingState : SmtpProcessState
	{
		public PlainAuthenticatingState(SmtpProcessor processor)
		{
			_Processor = processor;
		}
		public override SmtpProcessState ReceiveClientMessage(String text)
		{
			SmtpProcessState state = this;
			String s = SmtpServer.FromBase64String(text);
			String[] ss = s.Split('\0');
			SmtpRequestCommand cm = SmtpServer.GetRequestCommand(text);

			if (this.IsRsetOrQuit(cm) == true) { return this.CreateState(cm); }

			if (ss.Length == 3)
			{
				String userName = ss[0];
				String password = ss[2];
				if (_Processor.DataProvider.Authenticate(userName, password) == true)
				{
					state = new ServerReadyState(_Processor, true);
					state.ServerMessage = SmtpServer.CreateMessage(SmtpCommandResultCode.AuthenticationSuccessful);
				}
				else
				{
					state.ServerMessage = SmtpServer.CreateMessage(SmtpCommandResultCode.TemporaryAuthenticationFailure);
				}
			}
			else
			{
				state.ServerMessage = SmtpServer.CreateMessage(SmtpCommandResultCode.SyntaxError_CommandUnrecognized);
			}
			return state;
		}
		private Boolean ValidateCommand(String text)
		{
			String s = MailParser.FromBase64String(text);
			String[] ss = s.Split('\0');

			if (ss.Length == 3)
			{
				return true;
			}
			return false;
		}
	}
}
