/*------------------------------------------------------------------------------
 This code is auto-generated in the HLinq schema generator.
 Last update (2010/01/26)
 HLinq version: 0.1.0
------------------------------------------------------------------------------*/
/*-------------------------------------------------------
NameFPop3 account table
Description

-------------------------------------------------------*/
CREATE TABLE [dbo].[MailAccount] 
([UserName] NVarChar (400) NOT NULL 
,[Password] NVarChar (100) NOT NULL 
,[AuthenticateTime] DateTimeOffset (0) 
,[IsConnect] Bit NOT NULL 

)
GO


ALTER TABLE [dbo].[MailAccount] ADD CONSTRAINT [PK_MailAccount] PRIMARY KEY NONCLUSTERED ([UserName]
)
GO


/*-------------------------------------------------------
NameFMail data
Description

-------------------------------------------------------*/
CREATE TABLE [dbo].[MailData] 
([CD] UniqueIdentifier NOT NULL 
,[UserName] NVarChar (400) NOT NULL 
,[ReceiveTime] DateTimeOffset (0) NOT NULL 
,[Size] Int NOT NULL 
,[Data] NVarChar (MAX) NOT NULL 

)
GO


ALTER TABLE [dbo].[MailData] ADD CONSTRAINT [PK_MailData] PRIMARY KEY NONCLUSTERED ([CD]
)
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MailAccountSelectAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[MailAccountSelectAll]
GO
/*-------------------------------------------------------
NameFMailAccountSelectAll
Description

-------------------------------------------------------*/
CREATE PROCEDURE MailAccountSelectAll
AS 

SELECT 
[UserName]
,[Password]
,[AuthenticateTime]
,[IsConnect]
FROM [MailAccount] WITH(NOLOCK)

GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MailAccountSelectBy_PrimaryKey]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[MailAccountSelectBy_PrimaryKey]
GO
/*-------------------------------------------------------
NameFMailAccountSelectBy_PrimaryKey
Description

-------------------------------------------------------*/
CREATE PROCEDURE MailAccountSelectBy_PrimaryKey
(
@PK_UserName NVarChar (400) 
) AS 

SELECT 
[UserName]
,[Password]
,[AuthenticateTime]
,[IsConnect]
FROM [MailAccount] WITH(NOLOCK)
WHERE [UserName] = @PK_UserName 

GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MailAccountInsert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[MailAccountInsert]
GO
/*-------------------------------------------------------
NameFMailAccountInsert
Description

-------------------------------------------------------*/
CREATE PROCEDURE MailAccountInsert
(
@UserName NVarChar (400) 
,@Password NVarChar (100) 
,@AuthenticateTime DateTimeOffset (0) 
,@IsConnect Bit 
) AS 

INSERT INTO [MailAccount]
([UserName]
,[Password]
,[AuthenticateTime]
,[IsConnect]
)
VALUES 
(@UserName
,@Password
,@AuthenticateTime
,@IsConnect
)

GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MailAccountUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[MailAccountUpdate]
GO
/*-------------------------------------------------------
NameFMailAccountUpdate
Description

-------------------------------------------------------*/
CREATE PROCEDURE MailAccountUpdate
(
@UserName NVarChar (400) 
,@Password NVarChar (100) 
,@AuthenticateTime DateTimeOffset (0) 
,@IsConnect Bit 
,@PK_UserName NVarChar (400) 
) AS 

IF(
	@UserName = @PK_UserName
)
BEGIN
	UPDATE [MailAccount]
	SET [Password] = @Password
		,[AuthenticateTime] = @AuthenticateTime
		,[IsConnect] = @IsConnect
	WHERE [UserName] = @PK_UserName 
END
ELSE
BEGIN
	UPDATE [MailAccount]
	SET [UserName] = @UserName
		,[Password] = @Password
		,[AuthenticateTime] = @AuthenticateTime
		,[IsConnect] = @IsConnect
	WHERE [UserName] = @PK_UserName 
END

GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MailAccountDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[MailAccountDelete]
GO
/*-------------------------------------------------------
NameFMailAccountDelete
Description

-------------------------------------------------------*/
CREATE PROCEDURE MailAccountDelete
(
@PK_UserName NVarChar (400) 
) AS 

DELETE [MailAccount]
WHERE [UserName] = @PK_UserName 

GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MailAccountSearchBy_Value]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[MailAccountSearchBy_Value]
GO
/*-------------------------------------------------------
NameFMailAccountSearchBy_Value
Description

-------------------------------------------------------*/
CREATE PROCEDURE MailAccountSearchBy_Value
(
@SearchValue VarChar (8000) 
) AS 

SELECT 
[UserName]
,[Password]
,[AuthenticateTime]
,[IsConnect]
FROM [MailAccount] WITH(NOLOCK)
WHERE [UserName] LIKE @SearchValue 
	OR [Password] LIKE @SearchValue 

GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MailDataSelectAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[MailDataSelectAll]
GO
/*-------------------------------------------------------
NameFMailDataSelectAll
Description

-------------------------------------------------------*/
CREATE PROCEDURE MailDataSelectAll
AS 

SELECT 
[CD]
,[UserName]
,[ReceiveTime]
,[Size]
,[Data]
FROM [MailData] WITH(NOLOCK)

GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MailDataSelectBy_PrimaryKey]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[MailDataSelectBy_PrimaryKey]
GO
/*-------------------------------------------------------
NameFMailDataSelectBy_PrimaryKey
Description

-------------------------------------------------------*/
CREATE PROCEDURE MailDataSelectBy_PrimaryKey
(
@PK_CD UniqueIdentifier 
) AS 

SELECT 
[CD]
,[UserName]
,[ReceiveTime]
,[Size]
,[Data]
FROM [MailData] WITH(NOLOCK)
WHERE [CD] = @PK_CD 

GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MailDataInsert]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[MailDataInsert]
GO
/*-------------------------------------------------------
NameFMailDataInsert
Description

-------------------------------------------------------*/
CREATE PROCEDURE MailDataInsert
(
@CD UniqueIdentifier 
,@UserName NVarChar (400) 
,@ReceiveTime DateTimeOffset (0) 
,@Size Int 
,@Data NVarChar (MAX) 
) AS 

INSERT INTO [MailData]
([CD]
,[UserName]
,[ReceiveTime]
,[Size]
,[Data]
)
VALUES 
(@CD
,@UserName
,@ReceiveTime
,@Size
,@Data
)

GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MailDataUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[MailDataUpdate]
GO
/*-------------------------------------------------------
NameFMailDataUpdate
Description

-------------------------------------------------------*/
CREATE PROCEDURE MailDataUpdate
(
@CD UniqueIdentifier 
,@UserName NVarChar (400) 
,@ReceiveTime DateTimeOffset (0) 
,@Size Int 
,@Data NVarChar (MAX) 
,@PK_CD UniqueIdentifier 
) AS 

IF(
	@CD = @PK_CD
)
BEGIN
	UPDATE [MailData]
	SET [UserName] = @UserName
		,[ReceiveTime] = @ReceiveTime
		,[Size] = @Size
		,[Data] = @Data
	WHERE [CD] = @PK_CD 
END
ELSE
BEGIN
	UPDATE [MailData]
	SET [CD] = @CD
		,[UserName] = @UserName
		,[ReceiveTime] = @ReceiveTime
		,[Size] = @Size
		,[Data] = @Data
	WHERE [CD] = @PK_CD 
END

GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MailDataDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[MailDataDelete]
GO
/*-------------------------------------------------------
NameFMailDataDelete
Description

-------------------------------------------------------*/
CREATE PROCEDURE MailDataDelete
(
@PK_CD UniqueIdentifier 
) AS 

DELETE [MailData]
WHERE [CD] = @PK_CD 

GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MailDataSearchBy_Value]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[MailDataSearchBy_Value]
GO
/*-------------------------------------------------------
NameFMailDataSearchBy_Value
Description

-------------------------------------------------------*/
CREATE PROCEDURE MailDataSearchBy_Value
(
@SearchValue VarChar (8000) 
) AS 

SELECT 
[CD]
,[UserName]
,[ReceiveTime]
,[Size]
,[Data]
FROM [MailData] WITH(NOLOCK)
WHERE [UserName] LIKE @SearchValue 
	OR [Size] LIKE @SearchValue 
	OR [Data] LIKE @SearchValue 

GO


--Create StoredProcedureBy_ForeignKey
CREATE PROCEDURE MailDataSelectBy_UserName
(
@UserName NVarChar (400)  = '%' 
) AS 

SELECT 
[CD]
,[UserName]
,[ReceiveTime]
,[Size]
,[Data]
FROM [MailData] WITH(NOLOCK)
WHERE (
[UserName] = ISNUll(@UserName, [UserName]) 
)


GO


CREATE PROCEDURE MailDataDeleteBy_UserName
(
@UserName NVarChar (400) 
) AS 

DELETE [MailData]
WHERE [UserName] = @UserName 

GO


--Create CustomStoredProcedure
CREATE PROCEDURE MailDataList
(
@UserName NVarChar (400) 
) AS 

select 
CD
,Row_Number() over(order by ReceiveTime asc) as RowIndex 
,Size 
from MailData with(nolock) 
where UserName = @UserName 

GO


CREATE PROCEDURE MailDataStat
(
@UserName NVarChar (400) 
) AS 

select count(CD) as MailCount,sum(Size) 
from MailData with(nolock) 
where UserName = @UserName 

GO


CREATE PROCEDURE MailDataSelectBy_UserName_RowIndex
(
@UserName NVarChar (400) 
,@RowIndex Int 
) AS 

select T2.* from 
(
	select 
	CD
	,Row_Number() over(order by ReceiveTime asc) as RowIndex
	from MailData with(nolock) 
	where UserName = @UserName 
) as T1 
inner join MailData as T2 with(nolock) 
on T1.CD = T2.CD 
where T1.RowIndex = @RowIndex 


GO


CREATE PROCEDURE MailDataDeleteBy_UserName_RowIndex
(
@UserName NVarChar (400) 
,@RowIndex Int 
) AS 


delete MailData 
where CD = 
(
	select CD from 
	(
		select 
		CD
		,Row_Number() over(order by ReceiveTime asc) as RowIndex
		from MailData with(nolock) 
		where UserName = @UserName 
	) as T1 
	where T1.RowIndex = @RowIndex 
)

GO


--Create CustomScript
--Create Relation
Alter Table MailData
Add Constraint MailData_UserName_MailAccount
Foreign Key (
UserName

) References MailAccount (
UserName

)
On Update Cascade
On Delete Cascade

GO


