﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Data;
using Higuchi.Net.Mail.Data;
using Higuchi.Net.Mail;

namespace Higuchi.Net.Mail.Data
{
	public class SqlServerDataProvider : IMailDataProvider
	{
		private List<String> _AuthenticatedUserNameList = new List<string>();
		public List<String> AuthenticatedUserNameList
		{
			get { return _AuthenticatedUserNameList; }
		}
		public Boolean Authenticate(String userName, String password)
		{
			if (String.IsNullOrEmpty(userName) == true ||
				String.IsNullOrEmpty(password) == true ||
				this._AuthenticatedUserNameList.Contains(userName) == true)
			{ return false; }

			var r = DB.Default.MailAccount.SelectBy_PrimaryKey(userName, false);
			if (r == null) { return false; }
			if (r.Password == password)
			{
				r.AuthenticateTime = DateTimeOffset.Now;
				r.IsConnect = true;
				r.Update();
				return true;
			}
			return false;
		}
		public Boolean AuthenticateAPop(String userName, String password, String timeStamp)
		{
			if (String.IsNullOrEmpty(userName) == true ||
				String.IsNullOrEmpty(password) == true ||
				this._AuthenticatedUserNameList.Contains(userName) == true)
			{ return false; }

			var r = DB.Default.MailAccount.SelectBy_PrimaryKey(userName, false);
			if (r == null) { return false; }
			if (password == MailParser.ToMd5DigestString(timeStamp + r.Password))
			{
				r.AuthenticateTime = DateTimeOffset.Now;
				r.IsConnect = true;
				r.Update();
				return true;
			}
			return false;
		}
		public void Save(String userName, String data)
		{
			MailData.Record r = null;
			r = new MailData.Record(Guid.NewGuid());
			r.UserName = userName;
			r.ReceiveTime = DateTimeOffset.Now;
			r.Size = data.Length;
			r.Data = data;
			r.Insert();
		}
		public Boolean IsConnect(String userName)
		{
			var r = DB.Default.MailAccount.SelectBy_PrimaryKey(userName, false);
			if (r == null) { return false; }
			return r.IsConnect ?? false;
		}
		public String List(String userName)
		{
			StringBuilder sb = new StringBuilder();
			List<MailDataList.ResultSet> l = null;

			l = MailDataList.GetResultSet(userName);
			sb.AppendFormat("+OK {0} message.", l.Count);
			sb.AppendLine();
			for (int i = 0; i < l.Count; i++)
			{
				sb.AppendFormat("{0} {1}", i + 1, l[i].Size);
				sb.AppendLine();
			}
			sb.AppendLine(".");
			return sb.ToString();
		}
		public String Uidl(String userName)
		{
			StringBuilder sb = new StringBuilder();
			List<MailDataList.ResultSet> l = null;

			l = MailDataList.GetResultSet(userName);
			sb.AppendFormat("+OK {0} message.", l.Count);
			sb.AppendLine();
			for (int i = 0; i < l.Count; i++)
			{
				sb.AppendFormat("{0} {1}", i + 1, l[i].CD);
				sb.AppendLine();
			}
			sb.AppendLine(".");
			return sb.ToString();
		}
		public String Stat(String userName)
		{
			StringBuilder sb = new StringBuilder();
			List<MailDataStat.ResultSet> l = null;

			l = MailDataStat.GetResultSet(userName);
			if (l.Count == 1)
			{
				String.Format("+OK {0} {1}", l[0].MailCount, l[0].TotalSize);
			}
			return "+OK 0 0";
		}
		public String Retr(String userName, Int32 index)
		{
			var rs = MailDataSelectBy_UserName_RowIndex.GetResultSet(userName, index);
			if (rs.Count == 1)
			{
				return rs[0].Data;
			}
			return null;
		}
		public String Top(String userName, Int32 index, Int32 top)
		{
			var rs = MailDataSelectBy_UserName_RowIndex.GetResultSet(userName, index);
			if (rs.Count == 1)
			{
				StringReader sr = new StringReader(rs[0].Data);
				Int32? x = null;
				while (sr.Peek() > -1)
				{
					if (sr.ReadLine() == "")
					{
						x = 0;
					}
					x += 1;
					if (x == top){ break; }
				}
			}
			return null;
		}
		public void Dele(String userName, List<Int32> indexList)
		{
			List<MailDataDeleteBy_UserName_RowIndex> l = new List<MailDataDeleteBy_UserName_RowIndex>();
			
			indexList.Sort(Comparer<Int32>.Default.Compare);
			indexList.Reverse();
			for (int i = 0; i < indexList.Count; i++)
			{
				l.Add(new MailDataDeleteBy_UserName_RowIndex(userName, indexList[i]));
			}
			DB.Default.Save(IsolationLevel.ReadCommitted, l.ToArray());
		}
		public void Quit(String userName)
		{
			var r = DB.Default.MailAccount.SelectBy_PrimaryKey(userName, false);
			if (r == null) { return; }
			r.IsConnect = false;
			r.Update();
		}
	}
}
